unit Loginunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Registry, NdbAsa;

type
  TFmLogin = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    edDatabase: TEdit;
    edPassword: TEdit;
    edLoginName: TEdit;
    Panel3: TPanel;
    BtnOK: TButton;
    BtnCancel: TButton;
    RGRegistry: TRadioGroup;
    Bevel1: TBevel;
    Label1: TLabel;
    cbServerVersion: TComboBox;
    Label5: TLabel;
    Bevel2: TBevel;
    Label4: TLabel;
    Label6: TLabel;
    edServerName: TEdit;
    edServerParams: TEdit;
    Bevel3: TBevel;
    Label7: TLabel;
    edConnParams: TEdit;
    SpeedButton1: TSpeedButton;
    procedure btnBrowseDialogClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
  private
    Registry: TRegistry;
  public
    FDatabase:TAsaSession;
  end;

implementation

{$R *.DFM}

const
  NO_REGISTRY_ACTION  = 0;
  SAVE_TO_REGISTRY    = 1;
  CLEAR_FROM_REGISTRY = 2;

procedure TFmLogin.FormCreate(Sender: TObject);
begin
  Registry := TRegistry.Create;
  if Registry.OpenKey('\Software\Asta\Misc', True) then
  begin
    if Registry.ValueExists('LoginVersion') then
      cbServerVersion.ItemIndex := Registry.ReadInteger('LoginVersion')
    else
      cbServerVersion.ItemIndex := 4;
    edLoginName.Text := Registry.ReadString('LoginUser');
    edPassword.Text := Registry.ReadString('LoginPassword');
    edServerName.Text := Registry.ReadString('LoginEngineName');
    edServerParams.Text := Registry.ReadString('ServerParams');
    edDatabase.Text := Registry.ReadString('LoginDatabase');
    edConnParams.Text := Registry.ReadString('ClientParams');
    OpenDialog1.FileName := edDatabase.Text;
  end else
    MessageDlg('Unable to open or create registry key ' +
      'HKEY_LOCAL_USER\Software\Asta\Misc', mtError, [mbOK], 0 );
end;

procedure TFmLogin.FormDestroy(Sender: TObject);
begin
  Registry.Free;
end;

procedure TFmLogin.btnBrowseDialogClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edDatabase.Text := OpenDialog1.FileName;
end;

procedure TFmLogin.BtnOKClick(Sender: TObject);
begin
  // When we get here, the Registry component must be pointing to the right locn 
  case RGRegistry.ItemIndex of
    NO_REGISTRY_ACTION  : {Do Nothing};
    SAVE_TO_REGISTRY    : begin
        Registry.WriteInteger('LoginVersion', cbServerVersion.ItemIndex);
        Registry.WriteString('LoginUser', edLoginName.Text);
        Registry.WriteString('LoginPassword', edPassword.Text);
        Registry.WriteString('LoginEngineName', edServerName.Text);
        Registry.WriteString('ServerParams', edServerParams.Text);
        Registry.WriteString('LoginDatabase', edDatabase.Text);
        Registry.WriteString('ClientParams', edConnParams.Text);
      end;
    CLEAR_FROM_REGISTRY : begin
        Registry.DeleteValue('LoginVersion');
        Registry.DeleteValue('LoginUser');
        Registry.DeleteValue('LoginPassword');
        Registry.DeleteValue('LoginEngineName');
        Registry.DeleteValue('ServerParams');
        Registry.DeleteValue('LoginDatabase');
        Registry.DeleteValue('ClientParams');
      end;
  end;
  ModalResult := mrOK;
end;

end.
